unit untGetVam;
{ 
                   )_
               .-'(/ '-.
              /    `    \
             /  -     -  \
            (`  a     a  `)
             \     ^     /
              '. '---' .'
              .-`'---'`-.
             /           \
            /  / '   ' \  \
          _/  /|       |\  \_
         `/|\` |+++++++|`/|\`
              /\       /\
              | `-._.-` |
              \   / \   /
              |_ |   | _|
              | _|   |_ |
              (ooO   Ooo)
           TortriX Software
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, SolarCalendarPackage, Buttons, NumberToStr;

type
  TfrmGetVam = class(TForm)
    edtIDvam: TEdit;
    lblIDVam: TLabel;
    lblAccountID: TLabel;
    edtAccountID: TEdit;
    lblNameFamily: TLabel;
    edtNameFamily: TEdit;
    lblFathername: TLabel;
    edtFathername: TEdit;
    lblShId: TLabel;
    edtShID: TEdit;
    lblBDate: TLabel;
    edtBDate: TEdit;
    grpBody: TGroupBox;
    lblMvam: TLabel;
    edtMVam: TEdit;
    lblDSood: TLabel;
    edtDSood: TSpinEdit;
    lblMBaz: TLabel;
    edtMBaz: TEdit;
    lblDGVam: TLabel;
    edtDGVam: TSolarDatePicker;
    lblGT: TLabel;
    edtGT: TEdit;
    lblMGhest: TLabel;
    edtMGhest: TEdit;
    lblDPGhest: TLabel;
    edtDPGhest: TSolarDatePicker;
    btnCancel: TBitBtn;
    lblZamenC1: TLabel;
    lblZamenC2: TLabel;
    edtZamenCode1: TEdit;
    edtZamenCode2: TEdit;
    btnZamen1: TSpeedButton;
    btnZamen2: TSpeedButton;
    btnOk: TBitBtn;
    procedure btnCancelClick(Sender: TObject);
    procedure edtDSoodKeyPress(Sender: TObject; var Key: Char);
    procedure edtDSoodChange(Sender: TObject);
    procedure edtAccountIDKeyPress(Sender: TObject; var Key: Char);
    procedure edtMVamChange(Sender: TObject);
    procedure edtMVamKeyPress(Sender: TObject; var Key: Char);
    procedure edtMVamExit(Sender: TObject);
    procedure edtDSoodExit(Sender: TObject);
    procedure edtGTExit(Sender: TObject);
    procedure edtGTChange(Sender: TObject);
    procedure btnZamen1Click(Sender: TObject);
    procedure btnZamen2Click(Sender: TObject);
    procedure edtIDvamKeyPress(Sender: TObject; var Key: Char);
    procedure edtAccountIDExit(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmGetVam: TfrmGetVam;
  isClose: Boolean;
  
implementation

uses untInputZamenInfo, untDataModule, DB;

{$R *.dfm}
//*******************************TortriX Software*******************************
procedure TfrmGetVam.btnCancelClick(Sender: TObject);
begin
 frmGetVam.Close;
end;
//*******************************TortriX Software*******************************
procedure TfrmGetVam.edtDSoodKeyPress(Sender: TObject; var Key: Char);
begin
 if Key = #13 then
   begin
     Key := #0;
     Perform(WM_NEXTDLGCTL, 0, 0);
   end
  else
   Key := #0;
end;
//*******************************TortriX Software*******************************
procedure TfrmGetVam.edtDSoodChange(Sender: TObject);
begin
 if Length(edtDSood.Text) = 0 then
   edtDSood.Text := '0';
 edtMVamExit(Sender);
 edtGTExit(Sender);
end;
//*******************************TortriX Software*******************************
procedure TfrmGetVam.edtAccountIDKeyPress(Sender: TObject; var Key: Char);
begin
 if Key = #13 then
   begin
     Key := #0;
     Perform(WM_NEXTDLGCTL, 0, 0);
   end
  else if not(Key in ['0'..'9', #8]) then
    Key := #0;
end;
//*******************************TortriX Software*******************************
procedure TfrmGetVam.edtMVamChange(Sender: TObject);
begin
 _3Digit(edtMVam, edtMVamChange);
end;
//*******************************TortriX Software*******************************
procedure TfrmGetVam.edtMVamKeyPress(Sender: TObject; var Key: Char);
begin
 if key = #13 then
   begin
     Key := #0;
     Perform(WM_NEXTDLGCTL, 0, 0);
   end;
end;
//*******************************TortriX Software*******************************
procedure TfrmGetVam.edtMVamExit(Sender: TObject);
var
  BNum, T: LongInt;
  BSoo, S: LongInt;
  sSQL: string;
begin
  if Length(edtMVam.Text) = 0 then
    edtMVam.Text := '0';

  BNum := StrToInt(GetNumber(edtMVam.Text));
  T := BNum;
  BSoo := StrToInt(edtDSood.Text);
  BNum := Round(BNum + (BNum * BSoo / 100));
  sSQL := 'SELECT Reman FROM tblSandoq';
  frmDataModule.DBQuery.Close;
  frmDataModule.DBQuery.SQL.Clear;
  frmDataModule.DBQuery.SQL.Add(sSQL);
  frmDataModule.DBQuery.ExecSQL;
  frmDataModule.DBQuery.Open;

  S := frmDataModule.DBQuery.FieldByName('Reman').AsInteger;
  if T > S then
    begin
      MsDlg('  ', '      ', mtError, [
        mbOk], ['']);
      edtMVam.Clear;
      edtMVam.SetFocus;
    end
  else
    begin
      edtMBaz.Text := Set3Digit(IntToStr(BNum));
      edtGTExit(sender);
    end;
end;
//*******************************TortriX Software*******************************
procedure TfrmGetVam.edtDSoodExit(Sender: TObject);
begin
  edtMVamExit(Sender);
end;
//*******************************TortriX Software*******************************
procedure TfrmGetVam.edtGTExit(Sender: TObject);
var
  MG, TG: LongInt;
begin
 if(Length(edtGT.Text) = 0)or(StrToInt(edtGT.Text) = 0)then
   edtGT.Text := '1';

  MG := StrTOInt(GetNumber(edtMBaz.Text));
  TG := StrToInt(edtGT.Text);
  MG := Round(MG / TG);

  edtMGhest.Text := Set3Digit(IntToStr(MG));
end;
//*******************************TortriX Software*******************************
procedure TfrmGetVam.edtGTChange(Sender: TObject);
begin
 if(Length(edtGT.Text) = 0)or(StrToInt(edtGT.Text) = 0)then
   edtGT.Text := '1';
end;
//*******************************TortriX Software*******************************
procedure TfrmGetVam.btnZamen1Click(Sender: TObject);
begin
  frmInputZamenInfo.edtOZ.Text := '1';
  frmInputZamenInfo.ShowModal;
end;
//*******************************TortriX Software*******************************
procedure TfrmGetVam.btnZamen2Click(Sender: TObject);
begin
  frmInputZamenInfo.edtOZ.Text := '2';
  frmInputZamenInfo.ShowModal;
end;
//*******************************TortriX Software*******************************
procedure TfrmGetVam.edtIDvamKeyPress(Sender: TObject; var Key: Char);
begin
 if Key = #13 then
   begin
     Key := #0;
     Perform(WM_NEXTDLGCTL, 0, 0);
   end;
end;
//*******************************TortriX Software*******************************
procedure TfrmGetVam.edtAccountIDExit(Sender: TObject);
var
  sSQL: string;
begin
 if Length(edtAccountID.Text) > 0 then
   begin
     sSQL := 'SELECT NameFamily, Fathername, ShID, BDate FROM tblAccount ';
     sSQL := sSQL + 'WHERE AccountID = :PIDA';

     frmDataModule.DBQuery.Close;
     frmDataModule.DBQuery.SQL.Clear;
     frmDataModule.DBQuery.SQL.Add(sSQL);
     frmDataModule.DBQuery.Parameters.ParamByName('PIDA').Value := 
       edtAccountID.Text;
     frmDataModule.DBQuery.ExecSQL;
     frmDataModule.DBQuery.Open;

     if frmDataModule.DBQuery.RecordCount > 0 then
       begin
         edtNameFamily.Text := frmDataModule.DBQuery.FieldByName(
           'NameFamily').AsString;
         edtFathername.Text := frmDataModule.DBQuery.FieldByName(
           'Fathername').AsString;
         edtShID.Text := frmDataModule.DBQuery.FieldByName(
           'ShID').AsString;
         edtBDate.Text := frmDataModule.DBQuery.FieldByName(
           'BDate').AsString;
         grpBody.Enabled := True;
         edtMVam.SetFocus;  
       end
     else
       begin
         MsDlg('  ', '     ', mtError, [mbOk],
            ['']);
         FormShow(Sender);
       end;
   end
  else
    FormShow(Sender);
end;
//*******************************TortriX Software*******************************
procedure TfrmGetVam.FormShow(Sender: TObject);
var
  sSQL: string;
  sTas: string;
  idt: Integer;
begin
 isClose := False;
 sTas := '100000';
 edtNameFamily.Clear;
 edtFathername.Clear;
 edtAccountID.Clear;
 edtShID.Clear;
 edtBDate.Clear;
 edtMVam.Clear;
 edtDSood.Text := '16';
 edtMBaz.Clear;
 edtGT.Clear;
 edtMGhest.Clear;
 edtDGVam.Clear;
 edtDPGhest.Clear;
 edtZamenCode1.Clear;
 edtZamenCode2.Clear;
 edtAccountID.SetFocus;

 sSQL := 'SELECT COUNT(*) AS IDTas FROM tblGVam';
 frmDataModule.DBQuery.Close;
 frmDataModule.DBQuery.SQL.Clear;
 frmDataModule.DBQuery.SQL.Add(sSQL);
 frmDataModule.DBQuery.ExecSQL;
 frmDataModule.DBQuery.Open;

 idt := frmDataModule.DBQuery.FieldByName('IDTas').AsInteger;
 sTas := IntToStr(StrToInt(sTas) + idt);
 edtIDvam.Text := sTas;
end;
//*******************************TortriX Software*******************************
procedure TfrmGetVam.btnOkClick(Sender: TObject);
var
  sSQL: string;
  CheckInput: Boolean;
  Re, Mv: Longint;
begin
  CheckInput := False;
  if(Length(edtMVam.Text) = 0)or(StrToInt(GetNumber(edtMVam.Text)) = 0)or(Length(
    edtDGVam.Text) = 0)or(Length(edtDPGhest.Text) = 0)or(Length(
    edtZamenCode1.Text) = 0)or(Length(edtZamenCode2.Text) = 0)then
    CheckInput := True;

  if not CheckInput then
    begin
      sSQL := 'INSERT INTO tblGVam(IDVam, AccountID, ZamenCode1, ZamenCode2, ';
      sSQL := sSQL + 'MVam, MBaz, DGVam, GT, MGhest, DPGhest) VALUES(';
      sSQL := sSQL + QuotedStr(edtIDvam.Text) +', '+ QuotedStr(
        edtAccountID.Text) +', '+ QuotedStr(edtZamenCode1.Text) +', '+ 
        QuotedStr(edtZamenCode2.Text) +', '+ QuotedStr(GetNumber(edtMVam.Text)) 
        +', '+ QuotedStr(GetNumber(edtMBaz.Text)) +', '+ QuotedStr(
          edtDGVam.Text) +', '+ edtGT.Text +', '+ GetNumber(
          edtMGhest.Text) +', '+ QuotedStr(edtDPGhest.Text) +')';
      frmDataModule.DBSCommand.CommandText := sSQL;
      frmDataModule.DBSCommand.Execute;

      sSQL := 'SELECT Reman FROM tblSandoq';
      frmDataModule.DBQuery.Close;
      frmDataModule.DBQuery.SQL.Clear;
      frmDataModule.DBQuery.SQL.Add(sSQL);
      frmDataModule.DBQuery.ExecSQL;
      frmDataModule.DBQuery.Open;

      Re := frmDataModule.DBQuery.FieldByName('Reman').AsInteger;
      Mv := StrToInt(GetNumber(edtMVam.Text));
      Re := Re - Mv;

      sSQL := 'UPDATE tblSandoq SET Reman = ' + IntToStr(Re);
      frmDataModule.DBSCommand.CommandText := sSQL;
      frmDataModule.DBSCommand.Execute;
      isClose := True;
      MsDlg('  ', '    ', mtInformation, [
        mbOk], ['']);
      frmGetVam.Close;
    end
  else
    begin
      MsDlg('  ', '  ʘ      ', mtError,
        [mbOk], ['']);
      edtMVam.SetFocus;
    end;
end;
//*******************************TortriX Software*******************************
procedure TfrmGetVam.FormClose(Sender: TObject; var Action: TCloseAction);
var
 sSQL: string;
begin
 if not isClose then
   begin
     if Length(edtZamenCode1.Text) > 0 then
       begin
         frmDataModule.DBQuery.Close;
         sSQL := 'DELETE FROM tblZamen WHERE IDZamen='+ QuotedStr(
            edtZamenCode1.Text);
         frmDataModule.DBSCommand.CommandText := sSQL;
         frmDataModule.DBSCommand.Execute;
       end;
     if Length(edtZamenCode2.Text) > 0 then
       begin
         frmDataModule.DBQuery.Close;
         sSQL := 'DELETE FROM tblZamen WHERE IDZamen='+ QuotedStr(
            edtZamenCode2.Text);
         frmDataModule.DBSCommand.CommandText := sSQL;
         frmDataModule.DBSCommand.Execute;
       end;
   end;
end;
//*******************************TortriX Software*******************************
end.
