unit untLogin;
{ 
                   )_
               .-'(/ '-.
              /    `    \
             /  -     -  \
            (`  a     a  `)
             \     ^     /
              '. '---' .'
              .-`'---'`-.
             /           \
            /  / '   ' \  \
          _/  /|       |\  \_
         `/|\` |+++++++|`/|\`
              /\       /\
              | `-._.-` |
              \   / \   /
              |_ |   | _|
              | _|   |_ |
              (ooO   Ooo)
           TortriX Software
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, NumberToStr;

type
  TfrmLogin = class(TForm)
    pnlInput: TPanel;
    lblPassword: TLabel;
    edtPassword: TEdit;
    edtUsername: TEdit;
    lblUsername: TLabel;
    btnLogin: TBitBtn;
    btnCancel: TBitBtn;
    procedure edtUsernameKeyPress(Sender: TObject; var Key: Char);
    procedure btnLoginClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmLogin: TfrmLogin;

implementation

uses untDataModule, untMain;

{$R *.dfm}
//*******************************TortriX Software*******************************
procedure TfrmLogin.edtUsernameKeyPress(Sender: TObject; var Key: Char);
begin
 if Key = #13 then
   begin
     Key := #0;
     Perform(WM_NEXTDLGCTL, 0, 0);
   end;
end;
//*******************************TortriX Software*******************************
procedure TfrmLogin.btnLoginClick(Sender: TObject);
var
  sSQL: string;
begin
  if frmDataModule.DBQuery.Active then
    frmDataModule.DBQuery.Close;

  sSQL := 'SELECT stPassword FROM tblMembers ';
  sSQL := sSQL + 'WHERE stUsername=:Userparam';

    frmDataModule.DBQuery.SQL.Clear;
     frmDataModule.DBQuery.SQL.Add(sSQL);
      frmDataModule.DBQuery.Parameters.ParamByName('Userparam').Value :=
      edtUsername.Text;
     frmDataModule.DBQuery.ExecSQL;
    frmDataModule.DBQuery.Open;

   if(frmDataModule.DBQuery.FieldByName('stPassword').AsString =
     edtPassword.Text)and(frmDataModule.DBQuery.RecordCount > 0) then
     begin
       frmLogin.Hide;
       frmMain.Show;
     end
   else
     begin
       MsDlg('  ', '      ', mtError, [
         mbOk], ['']);
       edtUsername.Clear;
       edtPassword.Clear;
       edtUsername.SetFocus;
      end;
end;
//*******************************TortriX Software*******************************
procedure TfrmLogin.btnCancelClick(Sender: TObject);
begin
 frmLogin.Close;
end;
//*******************************TortriX Software*******************************
end.
