unit untMain;
{ 
                   )_
               .-'(/ '-.
              /    `    \
             /  -     -  \
            (`  a     a  `)
             \     ^     /
              '. '---' .'
              .-`'---'`-.
             /           \
            /  / '   ' \  \
          _/  /|       |\  \_
         `/|\` |+++++++|`/|\`
              /\       /\
              | `-._.-` |
              \   / \   /
              |_ |   | _|
              | _|   |_ |
              (ooO   Ooo)
           TortriX Software
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls, DateFarsi, jpeg, Menus, ImgList, ToolWin, XPMan,
  OleServer, JRO_TLB, ComObj, ShellAPI, WinSkinData, SkinCaption, NumberToStr;

type
  TfrmMain = class(TForm)
    pnlStatus: TStatusBar;
    TmrDateTime: TTimer;
    imgBackground: TImage;
    ProgramMenu: TMainMenu;
    mnuMoshtari: TMenuItem;
    mnuHesab: TMenuItem;
    mnuVam: TMenuItem;
    mnuHelp: TMenuItem;
    mnuMoshtari_AddM: TMenuItem;
    mnuMoshtari_EditM: TMenuItem;
    mnuMoshtari_Spilter0: TMenuItem;
    mnuMoshtari_ReportM: TMenuItem;
    mnuExit: TMenuItem;
    mnuHesab_VarizbeHeab: TMenuItem;
    mnuHesab_Bardashazhesab: TMenuItem;
    mnuHesab_Spilter0: TMenuItem;
    mnuHesab_ReportHesab: TMenuItem;
    mnuVam_Spilter0: TMenuItem;
    mnuVam_Paidvam_Aqsati: TMenuItem;
    mnuVam_Spilter1: TMenuItem;
    mnuVam_ReportVam_Aqsati: TMenuItem;
    mnuHelp_AboutUs: TMenuItem;
    mnuHelp_Spilter0: TMenuItem;
    mnuHelp_Help: TMenuItem;
    MenuImages: TImageList;
    ToolDoct: TCoolBar;
    ToolButton: TToolBar;
    mnuTools: TMenuItem;
    mnuTools_Calc: TMenuItem;
    mnuTools_Spilter0: TMenuItem;
    mnuTools_CR: TMenuItem;
    mnuTools_Backup: TMenuItem;
    mnuTools_Restore: TMenuItem;
    mnuTools_Spilter1: TMenuItem;
    mnuTools_Spilter2: TMenuItem;
    mnuTools_CLogin: TMenuItem;
    ToolButton1: TToolButton;
    ToolButton_Input: TToolButton;
    ToolButton3: TToolButton;
    ToolButton_Output: TToolButton;
    ToolButton_AccountR: TToolButton;
    ToolButton6: TToolButton;
    ToolButton_RHesab: TToolButton;
    ToolButton8: TToolButton;
    ToolButton_PaidVam: TToolButton;
    ToolButton10: TToolButton;
    ToolButton_Exit: TToolButton;
    mnuHesab_AddSandoq: TMenuItem;
    mnuHesab_Spilter2: TMenuItem;
    mnuVam_NewVam_Aqsati: TMenuItem;
    TitleSkin: TSkinCaption;
    EngineOfSkin: TSkinData;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TmrDateTimeTimer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckClose;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure mnuExitClick(Sender: TObject);
    procedure ToolButton_ExitClick(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure mnuMoshtari_AddMClick(Sender: TObject);
    procedure mnuMoshtari_EditMClick(Sender: TObject);
    procedure mnuMoshtari_DelMClick(Sender: TObject);
    procedure mnuHesab_AddSandoqClick(Sender: TObject);
    procedure mnuHesab_VarizbeHeabClick(Sender: TObject);
    procedure mnuHesab_BardashazhesabClick(Sender: TObject);
    procedure mnuHelp_AboutUsClick(Sender: TObject);
    procedure ToolButton_InputClick(Sender: TObject);
    procedure ToolButton_OutputClick(Sender: TObject);
    procedure mnuMoshtari_ReportMClick(Sender: TObject);
    procedure ToolButton_AccountRClick(Sender: TObject);
    procedure mnuHesab_ReportHesabClick(Sender: TObject);
    procedure ToolButton_RHesabClick(Sender: TObject);
    procedure mnuVam_NewVam_AqsatiClick(Sender: TObject);
    procedure mnuVam_ReportVam_AqsatiClick(Sender: TObject);
    procedure mnuTools_BackupClick(Sender: TObject);
    procedure mnuTools_RestoreClick(Sender: TObject);
    procedure mnuTools_CRClick(Sender: TObject);
    procedure mnuTools_CalcClick(Sender: TObject);
    procedure mnuVam_Paidvam_AqsatiClick(Sender: TObject);
    procedure ToolButton_PaidVamClick(Sender: TObject);
    procedure mnuTools_CLoginClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

uses untLogin, untNewAccount, untSearch, untBoxStore, untInputOutput,
  untAbout, untAccountReport, untHesabReport, untGetVam, untReportAQVam,
  untDataModule, untPaidGhest, untCLogin;

{$R *.dfm}
//*******************************TortriX Software*******************************
procedure TfrmMain.CheckClose;
var
  SaveResp: Integer;
begin
 if MsDlg('  ', '       Ͽ', mtConfirmation,
          [mbYes, mbNo], ['', '']) = mrYes then
  SaveResp := idYes
 else
  SaveResp := idNo;

  case SaveResp of
    idYes: {I want close};
    idNo : Abort;
  end;
end;
//*******************************TortriX Software*******************************
procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 frmLogin.Close;
end;
//*******************************TortriX Software*******************************
procedure TfrmMain.TmrDateTimeTimer(Sender: TObject);
begin
 pnlStatus.Panels[0].Text := SolarCompleteDate(Now);
 pnlStatus.Panels[1].Text := TimeToStr(Now);
end;
//*******************************TortriX Software*******************************
procedure TfrmMain.FormCreate(Sender: TObject);
var
 TBHandle  : HWnd;
 TBCoord   : TRect;
 CxScreen  ,
 CyScreen  ,
 CxFScreen ,
 CyFScreen ,
 CyCaption : Integer; 
begin
 frmMain.Top  := (Screen.Height - frmMain.Height) Div 2;
 frmMain.Left := (Screen.Width - frmMain.Width) Div 2;

 TBHandle := FindWindow('Shell_TrayWnd',nil);
 if TBHandle = 0 then
   frmMain.WindowState := wsMaximized
 else
  begin
   frmMain.WindowState := wsNormal;
   GetWindowRect(TBHandle,TBCoord);

   CxScreen  := GetSystemMetrics(SM_CXSCREEN);
   CyScreen  := GetSystemMetrics(SM_CYSCREEN);
   CxFScreen := GetSystemMetrics(SM_CXFULLSCREEN);
   CyFScreen := GetSystemMetrics(SM_CYFULLSCREEN);
   CyCaption := GetSystemMetrics(SM_CYCAPTION);

   frmMain.Width  := CxScreen - (CxScreen - CxFScreen) + 1;
   frmMain.Height := CyScreen - (CyScreen - CyFScreen) + CyCaption + 1 ;

   frmMain.Top  := 0;
   frmMain.Left := 0;
   if(TBCoord.Top = -2)and(TBCoord.Left = -2)then
     if TBCoord.Right > TBCoord.Bottom then
       frmMain.Top := TBCoord.Bottom
     else
       frmMain.Left := TBCoord.Right;
  end;
end;
//*******************************TortriX Software*******************************
procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  try
    CheckClose;
  except
    CanClose := False;
  end;
end;
//*******************************TortriX Software*******************************
procedure TfrmMain.mnuExitClick(Sender: TObject);
begin
  frmMain.Close;
end;
//*******************************TortriX Software*******************************
procedure TfrmMain.ToolButton_ExitClick(Sender: TObject);
begin
  mnuExit.Click;
end;
//*******************************TortriX Software*******************************
procedure TfrmMain.ToolButton1Click(Sender: TObject);
begin
  mnuMoshtari_AddM.Click;
end;
//*******************************TortriX Software*******************************
procedure TfrmMain.mnuMoshtari_AddMClick(Sender: TObject);
begin
  frmSearch.EdtType.Text := '1';
  frmSearch.ShowModal;
end;
//*******************************TortriX Software*******************************
procedure TfrmMain.mnuMoshtari_EditMClick(Sender: TObject);
begin
  frmSearch.EdtType.Text := '2';
  frmSearch.ShowModal;
end;
//*******************************TortriX Software*******************************
procedure TfrmMain.mnuMoshtari_DelMClick(Sender: TObject);
begin
  frmSearch.EdtType.Text := '3';
  frmSearch.ShowModal;
end;
//*******************************TortriX Software*******************************
procedure TfrmMain.mnuHesab_AddSandoqClick(Sender: TObject);
begin
 frmBoxStore.ShowModal;
end;
//*******************************TortriX Software*******************************
procedure TfrmMain.mnuHesab_VarizbeHeabClick(Sender: TObject);
begin
  frmInputOutput.edtType.Text := '1';
   frmInputOutput.pnlHint.Caption := '  ';
  frmInputOutput.ShowModal;
end;
//*******************************TortriX Software*******************************
procedure TfrmMain.mnuHesab_BardashazhesabClick(Sender: TObject);
begin
  frmInputOutput.edtType.Text := '2';
   frmInputOutput.pnlHint.Caption := '  ';
  frmInputOutput.ShowModal;
end;
//*******************************TortriX Software*******************************
procedure TfrmMain.mnuHelp_AboutUsClick(Sender: TObject);
begin
  frmAbout.ShowModal;
end;
//*******************************TortriX Software*******************************
procedure TfrmMain.ToolButton_InputClick(Sender: TObject);
begin
 mnuHesab_VarizbeHeab.Click;
end;
//*******************************TortriX Software*******************************
procedure TfrmMain.ToolButton_OutputClick(Sender: TObject);
begin
 mnuHesab_Bardashazhesab.Click;
end;
//*******************************TortriX Software*******************************
procedure TfrmMain.mnuMoshtari_ReportMClick(Sender: TObject);
begin
 frmAccountReport.ShowModal;
end;
//*******************************TortriX Software*******************************
procedure TfrmMain.ToolButton_AccountRClick(Sender: TObject);
begin
  mnuMoshtari_ReportM.Click;
end;
//*******************************TortriX Software*******************************
procedure TfrmMain.mnuHesab_ReportHesabClick(Sender: TObject);
begin
 frmHesabReport.ShowModal;
end;
//*******************************TortriX Software*******************************
procedure TfrmMain.ToolButton_RHesabClick(Sender: TObject);
begin
  mnuHesab_ReportHesab.Click;
end;
//*******************************TortriX Software*******************************
procedure TfrmMain.mnuVam_NewVam_AqsatiClick(Sender: TObject);
begin
 frmGetVam.ShowModal;
end;
//*******************************TortriX Software*******************************
procedure TfrmMain.mnuVam_ReportVam_AqsatiClick(Sender: TObject);
begin
 frmReportAQVam.ShowModal;
end;
//*******************************TortriX Software*******************************
procedure TfrmMain.mnuTools_BackupClick(Sender: TObject);
var
  strS, strD: string;
begin
  with TSaveDialog.Create(frmMain) do
  begin
    try
      Filter := 'Backup Database File|*.bdf';
      if Execute then
        begin
          strD := ChangeFileExt(FileName, '.bdf');
          strS := ExtractFilePath(Application.ExeName);
          strS := strS + 'Database\Database.mdb';

          if frmDataModule.DBConnection.Connected then
            frmDataModule.DBConnection.Close;

          CopyFile(PChar(strS), PChar(strD), False);
          MsDlg('  ', '       ',
            mtInformation, [mbOk], ['']);
          frmDataModule.DBConnection.Open;
        end;
    finally
      Free;
    end;
  end;
end;
//*******************************TortriX Software*******************************
procedure TfrmMain.mnuTools_RestoreClick(Sender: TObject);
var
  strS, strD: string;
begin
  with TOpenDialog.Create(frmMain) do
  begin
    try
      Filter := 'Backup Database File|*.bdf';
      if Execute then
        begin
          strS := FileName;
          strD := ExtractFilePath(Application.ExeName);
          strD := strD + 'Database\Database.mdb';

          if frmDataModule.DBConnection.Connected then
            frmDataModule.DBConnection.Close;

          CopyFile(PChar(strS), PChar(strD), False);
          MsDlg('  ', 'Ґ     ',
            mtInformation, [mbOk], ['']);
          frmDataModule.DBConnection.Open;
        end;
    finally
      Free;
    end;
  end;
end;
//*******************************TortriX Software*******************************
function CompactAndRepair(DB: string): Boolean;
var
  v: OLEvariant;
begin
  Result := True;
  try
    v := CreateOLEObject('JRO.JetEngine');
    try
      V.CompactDatabase('Provider=Microsoft.Jet.OLEDB.4.0;Data Source=' +
                                   DB + ';Jet OLEDB:Database Password=TtX65327',
                        'PProvider=Microsoft.Jet.OLEDB.4.0;Data Source=' +
           DB + 'x;Jet OLEDB:Engine Type=5;Jet OLEDB:Database Password=TtX65327'
                        );
      DeleteFile(DB);
      RenameFile(DB + 'x', DB);
    finally
      V := Unassigned;
    end;
  except
    Result := False;
  end;
end;
//*******************************TortriX Software*******************************
procedure TfrmMain.mnuTools_CRClick(Sender: TObject);
var
  DataPath: string;
begin
 if frmDataModule.DBConnection.Connected then
   frmDataModule.DBConnection.Close;

 DataPath := ExtractFilePath(Application.ExeName) + 'Database\Database.mdb';
  if CompactAndRepair(DataPath) then
   MsDlg('  ', '        ',
     mtInformation, [mbOK], [''])
  else
   MsDlg('  ', '        ',
     mtWarning, [mbOk], ['']);

  frmDataModule.DBConnection.Open;
end;
//*******************************TortriX Software*******************************
procedure TfrmMain.mnuTools_CalcClick(Sender: TObject);
var
 APath: string;
begin
 APath := ExtractFilePath(Application.ExeName) + 'Calc.exe';
 ShellExecute(0, 'Open', PChar(APath), nil, nil, SW_SHOWDEFAULT);
end;
//*******************************TortriX Software*******************************
procedure TfrmMain.mnuVam_Paidvam_AqsatiClick(Sender: TObject);
begin
  frmPaidGhest.ShowModal;
end;
//*******************************TortriX Software*******************************
procedure TfrmMain.ToolButton_PaidVamClick(Sender: TObject);
begin
  mnuVam_Paidvam_Aqsati.Click; 
end;
//*******************************TortriX Software*******************************
procedure TfrmMain.mnuTools_CLoginClick(Sender: TObject);
begin
 frmCLogin.ShowModal;
end;
//*******************************TortriX Software*******************************
end.
