unit untNewAccount;
{ 
                   )_
               .-'(/ '-.
              /    `    \
             /  -     -  \
            (`  a     a  `)
             \     ^     /
              '. '---' .'
              .-`'---'`-.
             /           \
            /  / '   ' \  \
          _/  /|       |\  \_
         `/|\` |+++++++|`/|\`
              /\       /\
              | `-._.-` |
              \   / \   /
              |_ |   | _|
              | _|   |_ |
              (ooO   Ooo)
           TortriX Software
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, SolarCalendarPackage, Buttons, NumberToStr;

type
  TfrmNewAccount = class(TForm)
    grpBody: TGroupBox;
    grpIDAccount: TGroupBox;
    lblAccountID: TLabel;
    edtAcountId: TEdit;
    lblNameFamily: TLabel;
    lblFathername: TLabel;
    lblShID: TLabel;
    lblBDate: TLabel;
    lblAddress: TLabel;
    lblTPhone: TLabel;
    lblAccountType: TLabel;
    lblSupply: TLabel;
    lblADate: TLabel;
    edtNameFamily: TEdit;
    edtFathername: TEdit;
    edtSHId: TEdit;
    edtBDate: TSolarDatePicker;
    edtAddress: TEdit;
    edtTPhone: TEdit;
    edtAccountType: TComboBox;
    edtSupply: TEdit;
    edtADate: TSolarDatePicker;
    btnCancel: TBitBtn;
    btnOk: TBitBtn;
    procedure btnCancelClick(Sender: TObject);
    procedure edtADateKeyPress(Sender: TObject; var Key: Char);
    procedure edtNameFamilyKeyPress(Sender: TObject; var Key: Char);
    procedure edtSupplyKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
    procedure edtSupplyChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmNewAccount: TfrmNewAccount;
  TempSupply: LongInt = 0;

implementation

uses untSearch, untDataModule, DB;

{$R *.dfm}
//*******************************TortriX Software*******************************
procedure TfrmNewAccount.btnCancelClick(Sender: TObject);
begin
 frmNewAccount.Close;
end;
//*******************************TortriX Software*******************************
procedure TfrmNewAccount.edtADateKeyPress(Sender: TObject; var Key: Char);
begin
  Key := #0;
  Perform(WM_NEXTDLGCTL, 0, 0);
end;
//*******************************TortriX Software*******************************
procedure TfrmNewAccount.edtNameFamilyKeyPress(Sender: TObject;
  var Key: Char);
begin
  if key = #13 then
    begin
      Key := #0;
      Perform(WM_NEXTDLGCTL, 0, 0);
    end;
end;
//*******************************TortriX Software*******************************
procedure TfrmNewAccount.edtSupplyKeyPress(Sender: TObject; var Key: Char);
begin
 if Key = #13 then
   begin
     Key := #0;
     Perform(WM_NEXTDLGCTL, 0, 0); 
   end
  else if not (Key in ['0'..'9', #8]) then
    Key := #0;
end;
//*******************************TortriX Software*******************************
procedure TfrmNewAccount.FormShow(Sender: TObject);
begin
 edtNameFamily.SetFocus;
 if frmSearch.EdtType.Text = '2' then
   TempSupply := StrToInt(GetNumber(edtSupply.Text));
end;
//*******************************TortriX Software*******************************
procedure TfrmNewAccount.btnOkClick(Sender: TObject);
var
 sSQL: string;
 CheckInput: Boolean;
 CReman: LongInt;
begin
  CheckInput := False;
  if(Length(edtNameFamily.Text) = 0)or(Length(edtFathername.Text) = 0)or(Length(
    edtSHId.Text) = 0)or(Length(edtBDate.Text) = 0)or(Length(edtAddress.Text) =
    0)or(Length(edtTPhone.Text) = 0)or(Length(edtAccountType.Text) = 0)or(
    Length(edtSupply.Text) = 0)or(Length(edtADate.Text) = 0)then
    CheckInput := True;

  if frmSearch.EdtType.Text = '1' then
    begin
      if not CheckInput then
       begin
        if MsDlg('  ', '      Ͽ', 
          mtConfirmation, [mbYes, mbNo] , ['', '']) = mrYes then
           begin
             sSQL := 'INSERT INTO tblAccount(AccountID, NameFamily, FatherName, ' +
               'ShID, ';
             sSQL := sSQL + 'BDate, Address, TPhone, AccountType, Supply, ' +
               'ADate) VALUES(';
             sSQL := sSQL + QuotedStr(edtAcountId.Text) +', '+ QuotedStr(
             edtNameFamily.Text) +', '+ QuotedStr(edtFathername.Text) +', '+
             QuotedStr(edtSHId.Text) +', '+ QuotedStr(edtBDate.Text) +', '+
             QuotedStr(edtAddress.Text) +', '+ QuotedStr(edtTPhone.Text) +', '+
             QuotedStr(edtAccountType.Text) +', '+ GetNumber(edtSupply.Text) +', '+
             QuotedStr(edtADate.Text) +')';

            frmDataModule.DBSCommand.CommandText := sSQL;
            frmDataModule.DBSCommand.Execute;

            sSQL := 'SELECT Reman FROM tblSandoq';
            frmDataModule.DBQuery.Close;
             frmDataModule.DBQuery.SQL.Clear;
             frmDataModule.DBQuery.SQL.Add(sSQL);
             frmDataModule.DBQuery.ExecSQL;
            frmDataModule.DBQuery.Open;
            CReman := frmDataModule.DBQuery.FieldByName(
              'Reman').AsInteger;
            CReman := CReman + StrToInt(GetNumber(edtSupply.Text));

            sSQL := 'UPDATE tblSandoq SET Reman=' + IntToStr(CReman);
            frmDataModule.DBSCommand.CommandText := sSQL;
            frmDataModule.DBSCommand.Execute;

            MsDlg('  ', '    ', 
              mtInformation, [mbOk], ['']);
            frmNewAccount.Close;
           end;
       end
      else
       begin
         MsDlg('  ', '  ʘ      ' +
           '', mtError, [mbOk] ,['']);
         edtNameFamily.SetFocus;
       end;
    end
  else if frmSearch.EdtType.Text = '2' then
    begin
      if not CheckInput then
       begin
        if MsDlg('  ', '      Ͽ', 
          mtConfirmation, [mbYes, mbNo] , ['', '']) = mrYes then
           begin
             sSQL := 'UPDATE tblAccount SET NameFamily = '+ QuotedStr(
                 edtNameFamily.Text) +', FatherName = '+ QuotedStr(
                 edtFathername.Text) +', ShID = '+ QuotedStr(edtSHId.Text);

             sSQL := sSQL + ', BDate = '+ QuotedStr(edtBDate.Text) +
               ', Address = '+ QuotedStr(edtAddress.Text) +', TPhone = '+ 
               QuotedStr(edtTPhone.Text) +', AccountType = '+ QuotedStr(
                 edtAccountType.Text) +', Supply = '+ GetNumber(edtSupply.Text) +', ADate =' +
                 ' '+ QuotedStr(edtADate.Text) +' WHERE AccountID= :PAccountID';

            frmDataModule.DBSCommand.CommandText := sSQL;
            frmDataModule.DBSCommand.Parameters.ParamByName('PAccountID').Value 
            := edtAcountId.Text;
            frmDataModule.DBSCommand.Execute;

            sSQL := 'SELECT Reman FROM tblSandoq';
            frmDataModule.DBQuery.Close;
             frmDataModule.DBQuery.SQL.Clear;
             frmDataModule.DBQuery.SQL.Add(sSQL);
             frmDataModule.DBQuery.ExecSQL;
            frmDataModule.DBQuery.Open;
            CReman := frmDataModule.DBQuery.FieldByName(
              'Reman').AsInteger;
            CReman := CReman - TempSupply;  
            CReman := CReman + StrToInt(GetNumber(edtSupply.Text));

            sSQL := 'UPDATE tblSandoq SET Reman=' + IntToStr(CReman);
            frmDataModule.DBSCommand.CommandText := sSQL;
            frmDataModule.DBSCommand.Execute;

            MsDlg('  ', '    ', 
              mtInformation, [mbOk], ['']);
            frmNewAccount.Close;
           end;
       end
      else
       begin
         MsDlg('  ', '  ʘ      ' +
           '', mtError, [mbOk], ['']);
         edtNameFamily.SetFocus;
       end;
    end;   
end;
//*******************************TortriX Software*******************************
procedure TfrmNewAccount.edtSupplyChange(Sender: TObject);
begin
  _3Digit(edtSupply, edtSupplyChange);
end;
//*******************************TortriX Software*******************************
end.
