unit untReportAQVam;
{ 
                   )_
               .-'(/ '-.
              /    `    \
             /  -     -  \
            (`  a     a  `)
             \     ^     /
              '. '---' .'
              .-`'---'`-.
             /           \
            /  / '   ' \  \
          _/  /|       |\  \_
         `/|\` |+++++++|`/|\`
              /\       /\
              | `-._.-` |
              \   / \   /
              |_ |   | _|
              | _|   |_ |
              (ooO   Ooo)
           TortriX Software
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, DBGrids, StdCtrls, Buttons, NumberToStr;

type
  TfrmReportAQVam = class(TForm)
    btnOk: TBitBtn;
    btnETE: TBitBtn;
    btnCancel: TBitBtn;
    ListAccount: TDBGrid;
    procedure btnCancelClick(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnETEClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmReportAQVam: TfrmReportAQVam;

implementation

uses untDataModule;

{$R *.dfm}
//*******************************TortriX Software*******************************
procedure TfrmReportAQVam.btnCancelClick(Sender: TObject);
begin
 frmReportAQVam.Close;
end;
//*******************************TortriX Software*******************************
procedure TfrmReportAQVam.btnOkClick(Sender: TObject);
var
  sSQL: string;
begin
  sSQL := 'SELECT tv.IDVam AS [ ], tv.AccountID AS [  ], ';
  sSQL := sSQL + 'ta.NameFamily AS [   ϐ], tv.MVam AS [ ], ' +
    'tv.MGhest AS [  ], ';
  sSQL := sSQL + 'tv.GT AS [   ], tv.DGVam AS [  ] ';
  sSQL := sSQL + 'FROM tblGVam tv, tblAccount ta WHERE tv.AccountID = ta.AccountID';

  frmDataModule.DBQuery.Close;
  frmDataModule.DBQuery.SQL.Clear;
  frmDataModule.DBQuery.SQL.Add(sSQL);
  frmDataModule.DBQuery.ExecSQL;
  frmDataModule.DBQuery.Open;
end;
//*******************************TortriX Software*******************************
procedure TfrmReportAQVam.FormShow(Sender: TObject);
begin
 frmDataModule.DBQuery.Close;
 btnOk.SetFocus;
end;
//*******************************TortriX Software*******************************
procedure TfrmReportAQVam.btnETEClick(Sender: TObject);
var
 sSQL: string;
begin
 with TSaveDialog.Create(frmReportAQVam) do
   begin
     try
       Filter := 'Excel File|*.xls';
       FileName := 'ExData.xls';
       if Execute then
         begin
  sSQL := 'SELECT tv.IDVam AS [ ], tv.AccountID AS [  ], ';
  sSQL := sSQL + 'ta.NameFamily AS [   ϐ], tv.MVam AS [ ], ' +
    'tv.MGhest AS [  ], ';
  sSQL := sSQL + 'tv.GT AS [   ], tv.DGVam AS [  ] ';
  sSQL := sSQL + 'INTO EData IN "'+ FileName +'" "Excel 8.0;" FROM tblGVam tv, ' +
    'tblAccount ta WHERE tv.AccountID = ta.AccountID';

  frmDataModule.DBSCommand.CommandText := sSQL;
  frmDataModule.DBSCommand.Execute;

  MsDlg('  ', '    ǘ  ', mtInformation, [mbOk],
   ['']);
         end;
     finally
       Free;
     end;
   end;
end;
//*******************************TortriX Software*******************************
end.
