unit untBoxStore;
{ 
                   )_
               .-'(/ '-.
              /    `    \
             /  -     -  \
            (`  a     a  `)
             \     ^     /
              '. '---' .'
              .-`'---'`-.
             /           \
            /  / '   ' \  \
          _/  /|       |\  \_
         `/|\` |+++++++|`/|\`
              /\       /\
              | `-._.-` |
              \   / \   /
              |_ |   | _|
              | _|   |_ |
              (ooO   Ooo)
           TortriX Software
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Md5DeftEdit, ExtCtrls, NumberToStr;

type
  TfrmBoxStore = class(TForm)
    plnReman: TPanel;
    pnlAdd: TPanel;
    lblReman: TLabel;
    btnSave: TBitBtn;
    btnCancel: TBitBtn;
    lblMablaq: TLabel;
    edtMablaq: TEdit;
    btnAdd: TBitBtn;
    edtReman: TEdit;
    procedure edtMablaqChange(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure btnAddClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmBoxStore: TfrmBoxStore;

implementation

uses untDataModule, DB;

{$R *.dfm}
//*******************************TortriX Software*******************************
procedure TfrmBoxStore.edtMablaqChange(Sender: TObject);
begin
 _3Digit(edtMablaq, edtMablaqChange);
end;
//*******************************TortriX Software*******************************
procedure TfrmBoxStore.btnCancelClick(Sender: TObject);
begin
 frmBoxStore.Close;
end;
//*******************************TortriX Software*******************************
procedure TfrmBoxStore.btnAddClick(Sender: TObject);
var
  CNum, NNum: Longint;
begin
  if Length(edtMablaq.Text) > 0 then
    begin
      CNum := StrToInt(GetNumber(edtReman.Text));
      NNum := StrToInt(GetNumber(edtMablaq.Text));

      CNum := CNum + NNum;
      edtReman.Text := Set3Digit(IntTostr(CNum));
      edtMablaq.Text := '0';
    end;
end;
//*******************************TortriX Software*******************************
procedure TfrmBoxStore.FormShow(Sender: TObject);
var
 sSQL: string;
begin
  sSQL := 'SELECT Reman FROM tblSandoq';

  frmDataModule.DBQuery.Close;
  frmDataModule.DBQuery.SQL.Clear;
  frmDataModule.DBQuery.SQL.Add(sSQL);
  frmDataModule.DBQuery.ExecSQL;
  frmDataModule.DBQuery.Open;

  edtReman.Text := Set3Digit(frmDataModule.DBQuery.FieldByName(
    'Reman').AsString);
  if Length(edtReman.Text) = 0 then
    edtReman.Text := '0';
  edtMablaq.Text := '0';
  edtMablaq.SetFocus;
end;
//*******************************TortriX Software*******************************
procedure TfrmBoxStore.btnSaveClick(Sender: TObject);
var
 sSQL: string;
begin
  if MsDlg('  ', '      Ͽ', mtConfirmation,
    [mbYes, mbNo], ['', '']) = mrYes then
    begin
      sSQL := 'UPDATE tblSandoq SET Reman =' + GetNumber(edtReman.Text);

      frmDataModule.DBSCommand.CommandText := sSQL;
      frmDataModule.DBSCommand.Execute;

      MsDlg('  ', '    ', mtInformation, [
        mbOk], ['']);
      frmBoxStore.Close;
    end
  else
    btnCancel.SetFocus;
end;
//*******************************TortriX Software*******************************
end.
