unit untHesabReport;
{ 
                   )_
               .-'(/ '-.
              /    `    \
             /  -     -  \
            (`  a     a  `)
             \     ^     /
              '. '---' .'
              .-`'---'`-.
             /           \
            /  / '   ' \  \
          _/  /|       |\  \_
         `/|\` |+++++++|`/|\`
              /\       /\
              | `-._.-` |
              \   / \   /
              |_ |   | _|
              | _|   |_ |
              (ooO   Ooo)
           TortriX Software
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Grids, DBGrids, NumberToStr;

type
  TfrmHesabReport = class(TForm)
    grpFind: TGroupBox;
    grpFBNF: TGroupBox;
    chkLike: TCheckBox;
    edtNameFamily: TEdit;
    btnFindByNF: TBitBtn;
    grpFBID: TGroupBox;
    edtAccountID: TEdit;
    btnFindByID: TBitBtn;
    ListAccount: TDBGrid;
    btnCancel: TBitBtn;
    procedure btnCancelClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnFindByNFClick(Sender: TObject);
    procedure edtAccountIDKeyPress(Sender: TObject; var Key: Char);
    procedure btnFindByIDClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmHesabReport: TfrmHesabReport;

implementation

uses untDataModule;

{$R *.dfm}
//*******************************TortriX Software*******************************
procedure TfrmHesabReport.btnCancelClick(Sender: TObject);
begin
 frmHesabReport.Close;
end;
//*******************************TortriX Software*******************************
procedure TfrmHesabReport.FormShow(Sender: TObject);
begin
  frmDataModule.DBQuery.Close;
   edtNameFamily.Clear;
    edtAccountID.Clear;
   chkLike.Checked := False;
  edtNameFamily.SetFocus;
end;
//*******************************TortriX Software*******************************
procedure TfrmHesabReport.btnFindByNFClick(Sender: TObject);
var
 sSQL: string;
begin
  if Length(edtNameFamily.Text) > 0 then
    begin
      if not chkLike.Checked then
        begin
 sSQL := 'SELECT AccountID AS [ ], NameFamily AS [   ϐ]';
 sSQL := sSQL + ', Fathername AS [ ], ShID as [ ],';
 sSQL := sSQL + ' BDate AS [ ], AccountType AS [ ], ';
 sSQL := sSQL + 'Supply AS [], TPhone AS [ ]';
 sSQL := sSQL + ' FROM tblAccount WHERE NameFamily = '+ QuotedStr(
   edtNameFamily.Text);
        end
      else
        begin
 sSQL := 'SELECT AccountID AS [ ], NameFamily AS [   ϐ]';
 sSQL := sSQL + ', Fathername AS [ ], ShID as [ ],';
 sSQL := sSQL + ' BDate AS [ ], AccountType AS [ ], ';
 sSQL := sSQL + 'Supply AS [], TPhone AS [ ]';
 sSQL := sSQL + ' FROM tblAccount WHERE NameFamily LIKE(' + QuotedStr(
                  '%' + edtNameFamily.Text + '%') + ')';
        end;
      frmDataModule.DBQuery.Close;
      frmDataModule.DBQuery.SQL.Clear;
      frmDataModule.DBQuery.SQL.Add(sSQL);
      frmDataModule.DBQuery.ExecSQL;
      frmDataModule.DBQuery.Open;
    end
  else
    begin
      MsDlg('  ', '    ϐ     ', mtError,
       [mbOk], ['']);
      edtNameFamily.SetFocus;
    end;
end;
//*******************************TortriX Software*******************************
procedure TfrmHesabReport.edtAccountIDKeyPress(Sender: TObject;
  var Key: Char);
begin
 if not(Key in ['0'..'9', #8]) then
   Key := #0;
end;
//*******************************TortriX Software*******************************
procedure TfrmHesabReport.btnFindByIDClick(Sender: TObject);
var
 sSQL: string;
begin
  if Length(edtAccountID.Text) > 0 then
    begin
 sSQL := 'SELECT AccountID AS [ ], NameFamily AS [   ϐ]';
 sSQL := sSQL + ', Fathername AS [ ], ShID as [ ],';
 sSQL := sSQL + ' BDate AS [ ], AccountType AS [ ], ';
 sSQL := sSQL + 'Supply AS [], TPhone AS [ ]';
 sSQL := sSQL + ' FROM tblAccount WHERE AccountID =' + QuotedStr(
   edtAccountID.Text);
      frmDataModule.DBQuery.Close;
      frmDataModule.DBQuery.SQL.Clear;
      frmDataModule.DBQuery.SQL.Add(sSQL);
      frmDataModule.DBQuery.ExecSQL;
      frmDataModule.DBQuery.Open;
    end
  else
    begin
      MsDlg('  ', '       ', mtError,
       [mbOk], ['']);
      edtAccountID.SetFocus;
    end;
end;
//*******************************TortriX Software*******************************
end.
