unit untInputZamenInfo;
{ 
                   )_
               .-'(/ '-.
              /    `    \
             /  -     -  \
            (`  a     a  `)
             \     ^     /
              '. '---' .'
              .-`'---'`-.
             /           \
            /  / '   ' \  \
          _/  /|       |\  \_
         `/|\` |+++++++|`/|\`
              /\       /\
              | `-._.-` |
              \   / \   /
              |_ |   | _|
              | _|   |_ |
              (ooO   Ooo)
           TortriX Software
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, NumberToStr;

type
  TfrmInputZamenInfo = class(TForm)
    grpIDZamen: TGroupBox;
    lblIDZamen: TLabel;
    lblNameFamil: TLabel;
    lblAccountCode: TLabel;
    lblTPhone: TLabel;
    lblAddress: TLabel;
    edtIDzamen: TEdit;
    edtNameFamily: TEdit;
    edtAccountCode: TEdit;
    edtTPhone: TEdit;
    edtAddress: TEdit;
    btnOk: TBitBtn;
    btnCancel: TBitBtn;
    edtOZ: TEdit;
    procedure btnCancelClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
    procedure edtNameFamilyKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmInputZamenInfo: TfrmInputZamenInfo;

implementation

uses untDataModule, untGetVam;

{$R *.dfm}
//*******************************TortriX Software*******************************
procedure TfrmInputZamenInfo.btnCancelClick(Sender: TObject);
begin
 frmInputZamenInfo.Close;
end;
//*******************************TortriX Software*******************************
procedure TfrmInputZamenInfo.FormShow(Sender: TObject);
var
  sSQL: string;
  IDZamen: string;
  idz: Integer;
begin
  edtNameFamily.Clear;
  edtAccountCode.Clear;
  edtTPhone.Clear;
  edtAddress.Clear;
  edtNameFamily.SetFocus;

  IDZamen := '1100';
  sSQL := 'SELECT COUNT(*) AS IDZ FROM tblZamen';
  frmDataModule.DBQuery.Close;
  frmDataModule.DBQuery.SQL.Clear;
  frmDataModule.DBQuery.SQL.Add(sSQL);

  frmDataModule.DBQuery.ExecSQL;
  frmDataModule.DBQuery.Open;
  idz := frmDataModule.DBQuery.FieldByName('IDZ').AsInteger;
  IDZamen := IntToStr(StrToInt(IDZamen) + idz);

  edtIDzamen.Text := IDZamen;
end;
//*******************************TortriX Software*******************************
procedure TfrmInputZamenInfo.btnOkClick(Sender: TObject);
var
  sSQL: string;
  CheckInput: Boolean;
begin
  CheckInput := False;
  if(Length(edtNameFamily.Text) = 0)or(Length(edtAccountCode.Text) = 0 )or
    (Length(edtTPhone.Text) = 0)or(Length(edtAddress.Text) = 0)then
    CheckInput := True;

   if not CheckInput then
     begin
       if MsDlg('  ', '      Ͽ', mtConfirmation,
        [mbYes, mbNo], ['', '']) = mrYes then
         begin
           sSQL := 'INSERT INTO tblZamen(IDZamen, NameFamily, AccountCode, ';
           sSQL := sSQL + 'TPhone, Address) VALUES('+ QuotedStr(
             edtIDzamen.Text) +', '+ QuotedStr(edtNameFamily.Text) +', '+ 
             QuotedStr(edtAccountCode.Text) +', '+ QuotedStr(
             edtTPhone.Text) +', '+ QuotedStr(edtAddress.Text) + ')';
           frmDataModule.DBSCommand.CommandText := sSQL;
           frmDataModule.DBSCommand.Execute;

           if edtOZ.Text = '1' then
             frmGetVam.edtZamenCode1.Text := edtIDzamen.Text
           else if edtOZ.Text = '2' then
             frmGetVam.edtZamenCode2.Text := edtIDzamen.Text;
           MsDlg('  ', '    ',mtInformation, 
             [mbOk], ['']);
           frmInputZamenInfo.Close;
         end
       else
         btnCancel.SetFocus;
     end
   else
     begin
       MsDlg('  ', '  ʘ      ', mtError,
          [mbOk], ['']);
       edtNameFamily.SetFocus;
     end;
end;
//*******************************TortriX Software*******************************
procedure TfrmInputZamenInfo.edtNameFamilyKeyPress(Sender: TObject;
  var Key: Char);
begin
 if Key = #13 then
   begin
     Key := #0;
     Perform(WM_NEXTDLGCTL, 0, 0);
   end;
end;
//*******************************TortriX Software*******************************
end.
