unit untPaidGhest;
{ 
                   )_
               .-'(/ '-.
              /    `    \
             /  -     -  \
            (`  a     a  `)
             \     ^     /
              '. '---' .'
              .-`'---'`-.
             /           \
            /  / '   ' \  \
          _/  /|       |\  \_
         `/|\` |+++++++|`/|\`
              /\       /\
              | `-._.-` |
              \   / \   /
              |_ |   | _|
              | _|   |_ |
              (ooO   Ooo)
           TortriX Software
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, SolarCalendarPackage, Spin, NumberToStr;

type
  TfrmPaidGhest = class(TForm)
    grpBody: TGroupBox;
    btnCancel: TBitBtn;
    btnOk: TBitBtn;
    lblIDVam: TLabel;
    edtIDVam: TEdit;
    lblAccountID: TLabel;
    edtAccountID: TEdit;
    lblNameFamily: TLabel;
    edtNameFamily: TEdit;
    lblGT: TLabel;
    edtGT: TEdit;
    lblDPGhest: TLabel;
    edtDPGhest: TEdit;
    lblMBaz: TLabel;
    edtMBaz: TEdit;
    lblMGt: TLabel;
    edtMGt: TSpinEdit;
    lblMPaid: TLabel;
    edtMPaid: TEdit;
    lblDPaid: TLabel;
    edtDPaid: TSolarDatePicker;
    lblJer: TLabel;
    edtJer: TEdit;
    procedure btnCancelClick(Sender: TObject);
    procedure edtIDVamKeyPress(Sender: TObject; var Key: Char);
    procedure edtAccountIDKeyPress(Sender: TObject; var Key: Char);
    procedure edtDPaidKeyPress(Sender: TObject; var Key: Char);
    procedure edtJerChange(Sender: TObject);
    procedure edtJerExit(Sender: TObject);
    procedure edtMGtExit(Sender: TObject);
    procedure edtMGtKeyPress(Sender: TObject; var Key: Char);
    procedure edtIDVamExit(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure edtMGtChange(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmPaidGhest: TfrmPaidGhest;
  MGh: Longint;

implementation

uses untDataModule, DB, StrUtils;

{$R *.dfm}
//*******************************TortriX Software*******************************
procedure TfrmPaidGhest.btnCancelClick(Sender: TObject);
begin
 frmPaidGhest.Close;
end;
//*******************************TortriX Software*******************************
procedure TfrmPaidGhest.edtIDVamKeyPress(Sender: TObject; var Key: Char);
begin
 if Key = #13 then
   begin
     Key := #0;
     Perform(WM_NEXTDLGCTL, 0, 0);
   end
 else if not(Key in ['0'..'9', #8]) then
   Key := #0;
end;
//*******************************TortriX Software*******************************
procedure TfrmPaidGhest.edtAccountIDKeyPress(Sender: TObject;
  var Key: Char);
begin
 if Key = #13 then
   begin
     Key := #0;
     Perform(WM_NEXTDLGCTL, 0, 0);
   end;
end;
//*******************************TortriX Software*******************************
procedure TfrmPaidGhest.edtDPaidKeyPress(Sender: TObject; var Key: Char);
begin
 Key := #0;
 Perform(WM_NEXTDLGCTL, 0, 0);
end;
//*******************************TortriX Software*******************************
procedure TfrmPaidGhest.edtJerChange(Sender: TObject);
begin
  _3Digit(edtJer, edtJerChange);
end;
//*******************************TortriX Software*******************************
procedure TfrmPaidGhest.edtJerExit(Sender: TObject);
begin
 if Length(edtJer.Text) = 0 then
   edtJer.Text := '0';
end;
//*******************************TortriX Software*******************************
procedure TfrmPaidGhest.edtMGtExit(Sender: TObject);
var
 MP: Longint;
begin
 if(Length(edtMGt.Text) = 0)and(edtMGt.MinValue <> 0)then
   edtMGt.Text := '1';
  Mp := StrToInt(edtMGt.Text) * MGh;

  edtMPaid.Text := Set3Digit(IntToStr(Mp));
end;
//*******************************TortriX Software*******************************
procedure TfrmPaidGhest.edtMGtKeyPress(Sender: TObject; var Key: Char);
begin
 Key := #0;
 Perform(WM_NEXTDLGCTL, 0, 0);
end;
//*******************************TortriX Software*******************************
procedure TfrmPaidGhest.edtIDVamExit(Sender: TObject);
var
  sSQL: string;
begin
  if Length(edtIDVam.Text) > 0 then
    begin
     sSQL := 'SELECT AccountID, GT, MGhest, DPGhest, MBaz FROM tblGVam ';
     sSQL := sSQL + 'WHERE IDVam = :PIDV';

     frmDataModule.DBQuery.Close;
     frmDataModule.DBQuery.SQL.Clear;
     frmDataModule.DBQuery.SQL.Add(sSQL);
     frmDataModule.DBQuery.Parameters.ParamByName('PIDV').Value :=
       edtIDVam.Text;
     frmDataModule.DBQuery.ExecSQL;
     frmDataModule.DBQuery.Open;

      if frmDataModule.DBQuery.RecordCount > 0 then
        begin
         edtAccountID.Text := frmDataModule.DBQuery.FieldByName(
           'AccountID').AsString;
         edtGT.Text := frmDataModule.DBQuery.FieldByName(
           'GT').AsString;
         MGh :=  frmDataModule.DBQuery.FieldByName(
           'MGhest').AsInteger;
         edtDPGhest.Text := frmDataModule.DBQuery.FieldByName(
           'DPGhest').AsString;
         edtMBaz.Text := Set3Digit(frmDataModule.DBQuery.FieldByName(
           'MBaz').AsString);

         sSQL := 'SELECT NameFamily FROM tblAccount ';
         sSQL := sSQL + 'WHERE AccountID = :PIDA';

           frmDataModule.DBQuery.Close;
           frmDataModule.DBQuery.SQL.Clear;
           frmDataModule.DBQuery.SQL.Add(sSQL);
            frmDataModule.DBQuery.Parameters.ParamByName('PIDA').Value :=
              edtAccountID.Text;
            frmDataModule.DBQuery.ExecSQL;
           frmDataModule.DBQuery.Open;

          edtNameFamily.Text := frmDataModule.DBQuery.FieldByName(
           'NameFamily').AsString;

         edtMGt.MaxValue := StrToInt(edtGT.Text);
         if StrToInt(edtGT.Text) = 0 then
           edtMGt.MinValue := 0;
         grpBody.Enabled := True;
         edtMGtExit(Sender);
         edtMGt.SetFocus;
        end
      else
        begin
          MsDlg('  ', '     ', mtError, [
            mbOk], ['']);
          FormShow(Sender);
        end;
    end
  else
    FormShow(Sender);
end;
//*******************************TortriX Software*******************************
procedure TfrmPaidGhest.FormShow(Sender: TObject);
begin
  edtIDVam.Clear;
  edtAccountID.Clear;
  edtNameFamily.Clear;
  edtGT.Clear;
  edtDPGhest.Clear;
  edtMBaz.Clear;

  edtMGt.Text := '1';
  edtMPaid.Clear;
  edtDPaid.Clear;
  edtJer.Text := '0';
  MGh := 0;

  grpBody.Enabled := False;
  edtIDVam.SetFocus;
end;
//*******************************TortriX Software*******************************
procedure TfrmPaidGhest.edtMGtChange(Sender: TObject);
begin
  edtMGtExit(Sender);
end;
//*******************************TortriX Software*******************************
procedure TfrmPaidGhest.btnOkClick(Sender: TObject);
var
  sSQL, Dpg, z1, z2: string;
  MP, Jer, MB, Re: LongInt;
  y, m, d, Tv: Integer;
begin
  if Length(edtDPaid.Text) > 0 then
    begin
      Jer := StrToInt(GetNumber(edtJer.Text));
      MB := StrToInt(GetNumber(edtMBaz.Text));
      MP := StrToInt(GetNumber(edtMPaid.Text));
      Tv := StrToInt(edtGT.Text) - StrToInt(edtMGt.Text);
      Dpg := edtDPGhest.Text;
      y := StrToInt(MidStr(DPg, 1, 4));
      m := StrToInt(MidStr(DPg, 6, 2));
      d := StrToInt(MidStr(DPg, 9, 2));
      m := m + 1;
      if m > 12 then
        begin
         y := y + 1;
         m := m - 12;
        end;
      if Length(IntToStr(m)) < 2 then
        Dpg := IntToStr(y) +'/0'+ IntToStr(m) +'/'+ IntToStr(d)
      else
        Dpg := IntToStr(y) +'/'+ IntToStr(m) +'/'+ IntToStr(d);
      MB := MB - MP;
      sSQL := 'UPDATE tblGvam SET MBaz='+ IntToStr(MB) +', GT='+ IntToStr(Tv);
      sSQL := sSQL + ', DPGhest='+ QuotedStr(Dpg) +' WHERE IDVam = :pIDV';

      frmDataModule.DBSCommand.CommandText := sSQL;
      frmDataModule.DBSCommand.Parameters.ParamByName('pIDV').Value :=
        edtIDVam.Text;
      frmDataModule.DBSCommand.Execute;

      sSQL := 'SELECT Reman FROM tblSandoq';
      frmDataModule.DBQuery.Close;
      frmDataModule.DBQuery.SQL.Clear;
      frmDataModule.DBQuery.SQL.Add(sSQL);
      frmDataModule.DBQuery.ExecSQL;
      frmDataModule.DBQuery.Open;

      MP := MP + Jer;
      Re := frmDataModule.DBQuery.FieldByName('Reman').AsInteger;
      Re := Re + MP;

      sSQL := 'UPDATE tblSandoq SET Reman=' + IntToStr(Re);
      frmDataModule.DBSCommand.CommandText := sSQL;
      frmDataModule.DBSCommand.Execute;

      if Tv = 0 then
        begin
          sSQL := 'SELECT ZamenCode1, ZamenCode2 FROM tblGVam WHERE IDVam = :PIDV';
          frmDataModule.DBQuery.Close;
          frmDataModule.DBQuery.SQL.Clear;
          frmDataModule.DBQuery.SQL.Add(sSQL);
          frmDataModule.DBQuery.Parameters.ParamByName('PIDV').Value := 
            edtIDVam.Text;
          frmDataModule.DBQuery.ExecSQL;
          frmDataModule.DBQuery.Open;

          z1 := frmDataModule.DBQuery.FieldByName('ZamenCode1').AsString;
          z2 := frmDataModule.DBQuery.FieldByName('ZamenCode2').AsString;

          frmDataModule.DBQuery.Close;
          sSQL := 'DELETE FROM tblGVam WHERE IDVam='+ QuotedStr(edtIDVam.Text);
          frmDataModule.DBSCommand.CommandText := sSQL;
          frmDataModule.DBSCommand.Execute;

          sSQL := 'DELETE FROM tblZamen WHERE IDZamen='+ QuotedStr(z1);
          frmDataModule.DBSCommand.CommandText := sSQL;
          frmDataModule.DBSCommand.Execute;
          sSQL := 'DELETE FROM tblZamen WHERE IDZamen='+ QuotedStr(z2);
          frmDataModule.DBSCommand.CommandText := sSQL;
          frmDataModule.DBSCommand.Execute;
        end;

      MsDlg('  ', '       ', mtInformation, [
        mbOk], ['']);
      frmPaidGhest.Close;
    end
  else
    begin
      MsDlg('  ', '  ʘ      ', mtError,
        [mbOk], ['']);
      edtDPaid.SetFocus;
    end;
end;
//*******************************TortriX Software*******************************
end.
