unit untSearch;
{ 
                   )_
               .-'(/ '-.
              /    `    \
             /  -     -  \
            (`  a     a  `)
             \     ^     /
              '. '---' .'
              .-`'---'`-.
             /           \
            /  / '   ' \  \
          _/  /|       |\  \_
         `/|\` |+++++++|`/|\`
              /\       /\
              | `-._.-` |
              \   / \   /
              |_ |   | _|
              | _|   |_ |
              (ooO   Ooo)
           TortriX Software
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, NumberToStr;

type
  TfrmSearch = class(TForm)
    pnlBody: TPanel;
    lblTitle: TLabel;
    edtIDAccount: TEdit;
    btnFind: TBitBtn;
    btnCancel: TBitBtn;
    EdtType: TEdit;
    procedure FormShow(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure edtIDAccountKeyPress(Sender: TObject; var Key: Char);
    procedure btnFindClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmSearch: TfrmSearch;

implementation

uses untDataModule, untNewAccount;

{$R *.dfm}
//*******************************TortriX Software*******************************
procedure TfrmSearch.FormShow(Sender: TObject);
var
  sType, iId: Integer;
  sSQL, LID: string;
begin
  sType := StrToInt(EdtType.Text);
  if sType = 1 then
    begin
      LID := '1001';
      sSQL := 'SELECT COUNT(*) AS IDLast FROM tblAccount';

      frmDataModule.DBQuery.Close;
      frmDataModule.DBQuery.SQL.Clear;
      frmDataModule.DBQuery.SQL.Add(sSQL);
      frmDataModule.DBQuery.ExecSQL;
      frmDataModule.DBQuery.Open;

      iId := frmDataModule.DBQuery.FieldByName('IDLast').AsInteger;
      LID := IntToStr(StrToInt(LID) + iId);
      edtIDAccount.Text := LID;
    end
  else
    edtIDAccount.Clear;
  edtIDAccount.SetFocus;
end;
//*******************************TortriX Software*******************************
procedure TfrmSearch.btnCancelClick(Sender: TObject);
begin
 frmSearch.Close;
end;
//*******************************TortriX Software*******************************
procedure TfrmSearch.edtIDAccountKeyPress(Sender: TObject; var Key: Char);
begin
 if Key = #13 then
   begin
     Key := #0;
     Perform(WM_NEXTDLGCTL, 0, 0); 
   end
  else if not (Key in ['0'..'9', #8]) then
    Key := #0;
end;
//*******************************TortriX Software*******************************
procedure TfrmSearch.btnFindClick(Sender: TObject);
var
 sSQL: string;
begin
 if Length(edtIDAccount.Text) > 0 then
   begin
     sSQL := 'SELECT NameFamily, Fathername, ShID, BDate, Address, TPhone, ' ;
     sSQL := sSQL + 'AccountType, Supply, ADate FROM tblAccount ';
     sSQL := sSQL + 'WHERE AccountID= :AIDParam';

     frmDataModule.DBQuery.Close;
     frmDataModule.DBQuery.SQL.Clear;
     frmDataModule.DBQuery.SQL.Add(sSQL);
     frmDataModule.DBQuery.Parameters.ParamByName('AIDParam').Value :=
      edtIDAccount.Text;
     frmDataModule.DBQuery.ExecSQL;
     frmDataModule.DBQuery.Open;

     if EdtType.Text = '1' then    //Insert
       begin
         if frmDataModule.DBQuery.RecordCount = 0 then
           begin
             frmNewAccount.Caption := '          ';
             frmNewAccount.edtAcountId.Text := edtIDAccount.Text;

             frmNewAccount.edtNameFamily.Clear;
             frmNewAccount.edtFathername.Clear;
             frmNewAccount.edtSHId.Clear;
             frmNewAccount.edtBDate.Clear;
             frmNewAccount.edtAddress.Clear;
             frmNewAccount.edtTPhone.Clear;
             frmNewAccount.edtAccountType.Text := '';
             frmNewAccount.edtSupply.Clear;
             frmNewAccount.edtADate.Clear;

             frmNewAccount.btnOk.Caption := '';
             frmNewAccount.ShowModal;
             frmSearch.Close;
           end
         else
           begin
             MsDlg('  ', '    ʘ ', mtError, [
               mbOk], ['']);
             edtIDAccount.Clear;
             edtIDAccount.SetFocus;
           end;
       end
     else if EdtType.Text = '2' then       //Edit
       begin
         if frmDataModule.DBQuery.RecordCount > 0 then
           begin
             frmNewAccount.Caption := '         ';
             frmNewAccount.edtAcountId.Text := edtIDAccount.Text;

             frmNewAccount.edtNameFamily.Text :=
               frmDataModule.DBQuery.FieldByName('NameFamily').AsString;
             frmNewAccount.edtFathername.Text :=
               frmDataModule.DBQuery.FieldByName('Fathername').AsString;
             frmNewAccount.edtSHId.Text :=
               frmDataModule.DBQuery.FieldByName('ShID').AsString;
             frmNewAccount.edtBDate.Text :=
               frmDataModule.DBQuery.FieldByName('BDate').AsString;
             frmNewAccount.edtAddress.Text :=
               frmDataModule.DBQuery.FieldByName('Address').AsString;
             frmNewAccount.edtTPhone.Text :=
               frmDataModule.DBQuery.FieldByName('TPhone').AsString;
             frmNewAccount.edtAccountType.Text :=
               frmDataModule.DBQuery.FieldByName('AccountType').AsString;
             frmNewAccount.edtSupply.Text :=
               Set3Digit(frmDataModule.DBQuery.FieldByName('Supply').AsString);
             frmNewAccount.edtADate.Text :=
               frmDataModule.DBQuery.FieldByName('ADate').AsString;

             frmNewAccount.btnOk.Caption := '';
             frmNewAccount.ShowModal;
             frmSearch.Close;
           end
         else
           begin
             MsDlg('  ', '     ', mtError, [
               mbOk], ['']);
             edtIDAccount.Clear;
             edtIDAccount.SetFocus;
           end;
       end;
   end
  else
   begin
     MsDlg('  ', '     ', mtError, [mbOk], ['']);
     edtIDAccount.SetFocus;
   end;
end;
//*******************************TortriX Software*******************************
end.
